# disable binary striping
%global __os_install_post %{nil}

# disable creating useless empty debug packages
%global debug_package %{nil}

%define apacheuser apache
%define apachegroup apache
%define apachedir httpd

Summary: Monitoring Webinterface for Nagios/Naemon/Icinga and Shinken
Name: thruk
Version: 3.10
Release: 1%{?dist}
License: GPLv2
URL: http://thruk.org
Source0: https://download.thruk.org/pkg/v%{version}/src/%{name}-%{version}.tar.gz

BuildRequires: autoconf
BuildRequires: automake
BuildRequires: httpd
BuildRequires: npm
BuildRequires: patch
BuildRequires: perl
BuildRequires: perl-generators
BuildRequires: perl(ExtUtils::Install)
BuildRequires: perl(Module::Install)

Requires: cronie
Requires: httpd
Requires: mod_fcgid
Requires: wget

AutoReqProv: no
Requires: thruk-plugin-reporting = %{version}-%{release}

Requires: perl
Requires: perl-Carp
Requires: perl-Class-Inspector
Requires: perl-constant
Requires: perl-Cpanel-JSON-XS
Requires: perl-Crypt-Rijndael
Requires: perl-Data-Dumper
Requires: perl-Date-Calc
Requires: perl-Digest
Requires: perl-Encode
Requires: perl-Errno
Requires: perl-Exporter
Requires: perl-Fcntl
Requires: perl-File-Copy
Requires: perl-File-Temp
Requires: perl-GD
Requires: perl-Getopt-Long
Requires: perl-Hash-MultiValue
Requires: perl-HTTP-Message
Requires: perl-IO
Requires: perl-IO-Socket-IP
Requires: perl-IPC-Open3
Requires: perl-LWP-Protocol-https
Requires: perl-MIME-Base64
Requires: perl-MIME-Lite
Requires: perl-Module-Load
Requires: perl-parent
Requires: perl-PathTools
Requires: perl-Plack
Requires: perl-POSIX
Requires: perl-Scalar-List-Utils
Requires: perl-Socket
Requires: perl-Storable
Requires: perl-Template-Toolkit
Requires: perl-Thread-Queue
Requires: perl-threads
Requires: perl-Time-HiRes
Requires: perl-URI
Requires: perl-Plack
Requires: perl-Excel-Template

# These were provided by libthruk
Requires: perl-AppConfig
Requires: perl-Bit-Vector
Requires: perl-Carp-Clan
Requires: perl-Clone
Requires: perl-Compress-Raw-Bzip2
Requires: perl-Compress-Raw-Zlib
Requires: perl-Cookie-Baker
Requires: perl-Date-Manip
Requires: perl-DBD-MySQL
Requires: perl-DBI
Requires: perl-debugger
Requires: perl-Digest-SHA
Requires: perl-Email-Date-Format
Requires: perl-Encode-Locale
Requires: perl-FCGI
Requires: perl-FCGI-ProcManager
Requires: perl-File-ShareDir
Requires: perl-File-Slurp
Requires: perl-HTML-Parser
Requires: perl-HTML-Tagset
Requires: perl-HTTP-Cookies
Requires: perl-HTTP-Date
Requires: perl-HTTP-Entity-Parser
Requires: perl-HTTP-Headers-Fast
Requires: perl-HTTP-MultiPartParser
Requires: perl-HTTP-Negotiate
Requires: perl-IO-Compress
Requires: perl-IO-String
Requires: perl-IO-stringy
Requires: perl-JSON-MaybeXS
Requires: perl-libwww-perl
Requires: perl-Log-Log4perl
Requires: perl-Log-Log4perl-Appender-DBI
Requires: perl-Log-Log4perl-Appender-RRDs
Requires: perl-Log-Log4perl-Config-DOMConfigurator
Requires: perl-LWP-MediaTypes
Requires: perl-LWP-Protocol-https
Requires: perl-MIME-Lite
Requires: perl-Module-Load
Requires: perl-Net-HTTP
Requires: perl-OLE-Storage_Lite
Requires: perl-Parse-RecDescent
Requires: perl-Plack-Handler-FCGI
Requires: perl-Plack-Middleware-Log4perl
Requires: perl-Plack-Test
Requires: perl-Spreadsheet-WriteExcel
Requires: perl-Stream-Buffered
Requires: perl-Test-Simple
Requires: perl-Thread-Semaphore
Requires: perl-Tie-IxHash
Requires: perl-Try-Tiny
Requires: perl-WWW-Form-UrlEncoded
Requires: perl-XML-Parser

Requires(preun): systemd-units
Requires(postun): systemd-units
Requires(post): systemd-units

%description
Thruk is a multibackend monitoring webinterface which currently supports
Naemon, Nagios, Icinga and Shinken as backend using the Livestatus API. It is
designed to be a 'dropin' replacement and covers almost all of the original
features plus adds additional enhancements for large installations.

%package plugin-reporting
Summary: Thruk Gui Reporting Addon
Requires:%{name} = %{version}-%{release}
Requires: urw-fonts
AutoReqProv: no

%description plugin-reporting
This package contains the reporting addon for thruk useful for sla
and event reporting.

%prep

%setup -q

%build
export PERL5LIB="%{_datadir}/thruk/lib:%{perl_archlib}:%{perl_vendorarch}:%{perl_vendorlib}"

%configure \
    --bindir="%{_bindir}" \
    --datadir="%{_datadir}/thruk" \
    --libdir="%{_libdir}/thruk" \
    --localstatedir="%{_localstatedir}/lib/thruk" \
    --with-tempdir="%{_localstatedir}/cache/thruk" \
    --sysconfdir="%{_sysconfdir}/thruk" \
    --mandir="%{_mandir}" \
    --with-initdir="%{_initrddir}" \
    --with-logdir="%{_localstatedir}/log/thruk" \
    --with-logrotatedir="%{_sysconfdir}/logrotate.d" \
    --with-bashcompletedir="%{_sysconfdir}/bash_completion.d" \
    --with-thruk-libs="%{perl_archlib}:%{perl_vendorarch}:%{perl_vendorlib}" \
    --with-thruk-user="%{apacheuser}" \
    --with-thruk-group="%{apachegroup}" \
    --with-httpd-conf="%{_sysconfdir}/%{apachedir}/conf.d" \
    --with-htmlurl="/thruk"
%{__make} %{?_smp_mflags} all

# replace /usr/bin/env according to https://fedoraproject.org/wiki/Packaging:Guidelines#Shebang_lines
sed -e 's%/usr/bin/env perl%/usr/bin/perl%' -i \
    script/thruk_server.pl \
    support/thruk_authd.pl \

# this plugin is shipped separatly
rm plugins/plugins-enabled/reports2

%install
%{__make} install \
    DESTDIR="%{buildroot}" \
    INSTALL_OPTS="" \
    COMMAND_OPTS="" \
    INIT_OPTS=""

mkdir -p %{buildroot}%{_localstatedir}/lib/thruk

# enable su logrotate directive if required
sed -i -e 's/^.*#su/    su/' %{buildroot}/%{_sysconfdir}/logrotate.d/thruk-base
touch plugin-reporting.files

# files file cannot be empty
echo "%%defattr(-,root,root)" >> plugin-reporting.files

if test -e %{buildroot}%{_datadir}/thruk/script/phantomjs; then
  echo "%{_datadir}/thruk/script/phantomjs" >> plugin-reporting.files
fi

rm %{buildroot}%{_initrddir}/thruk

test -f %{buildroot}/usr/share/thruk/root/thruk/cache/thruk-panorama-*.js || exit 1

%pre
# save themes, plugins and ssi so we don't reenable them on every update
rm -rf /tmp/thruk_update
if [ -d /etc/thruk/themes/themes-enabled/. -a -e /etc/thruk/themes/themes-enabled/* ]; then
  mkdir -p /tmp/thruk_update/themes
  cp -rp /etc/thruk/themes/themes-enabled/* /tmp/thruk_update/themes/
fi
if [ -d /etc/thruk/plugins/plugins-enabled/. -a -e /etc/thruk/plugins/plugins-enabled/* ]; then
  mkdir -p /tmp/thruk_update/plugins
  cp -rp /etc/thruk/plugins/plugins-enabled/* /tmp/thruk_update/plugins/
fi
if [ -d /etc/thruk/ssi/. -a -e /etc/thruk/ssi/* ]; then
  mkdir -p /tmp/thruk_update/ssi
  cp -rp /etc/thruk/ssi/* /tmp/thruk_update/ssi/
fi

exit 0

%post
set +e
case "$*" in
  2)
    # Upgrading, restart apache webserver
        systemctl daemon-reload >/dev/null
        systemctl condrestart httpd.service >/dev/null

    rm -rf /var/cache/thruk/*
    /usr/bin/thruk -a clearcache,installcron --local > /dev/null
  ;;
  1)
    # Installing
    mkdir -p /var/cache/thruk/reports \
             /var/log/thruk \
             /etc/thruk/bp \
             /etc/thruk/panorama \
             /var/lib/thruk \
             /etc/thruk/thruk_local.d
    touch /var/log/thruk/thruk.log
    chown -R %{apacheuser}:%{apachegroup} \
                    /var/lib/thruk \
                    /var/cache/thruk \
                    /var/log/thruk \
                    /etc/thruk/plugins/plugins-enabled \
                    /etc/thruk/thruk_local.conf \
                    /etc/thruk/bp \
                    /etc/thruk/panorama \
                    /etc/thruk/thruk_local.d
    /usr/bin/crontab -l -u %{apacheuser} 2>/dev/null | /usr/bin/crontab -u %{apacheuser} -
     %systemd_post thruk.service

    rm -rf /var/cache/thruk/*
    /usr/bin/thruk -a clearcache,installcron --local > /dev/null

    echo "Thruk have been configured for http://$(hostname)/thruk/."
    echo "The default user is 'thrukadmin' with password 'thrukadmin'. You can usually change that by 'htpasswd /etc/thruk/htpasswd thrukadmin'"
  ;;
  *) echo case "$*" not handled in post
esac

if [ "$(getenforce 2>/dev/null)" = "Enforcing" ]; then
  echo "******************************************";
  echo "Thruk will not work when SELinux is enabled";
  echo "SELinux: "$(getenforce);
  echo "******************************************";
fi

exit 0

%posttrans
# restore themes and plugins
if [ -d /tmp/thruk_update/themes/. ]; then
  # do not remove the new default theme
  test -h /tmp/thruk_update/themes/Light || mv /etc/thruk/themes/themes-enabled/Light /etc/thruk/themes/themes-enabled/.Light 
  test -h /tmp/thruk_update/themes/Dark  || mv /etc/thruk/themes/themes-enabled/Dark  /etc/thruk/themes/themes-enabled/.Dark
  rm -f /etc/thruk/themes/themes-enabled/*
  cp -rp /tmp/thruk_update/themes/* /etc/thruk/themes/themes-enabled/
  test -h /etc/thruk/themes/themes-enabled/.Light && mv /etc/thruk/themes/themes-enabled/.Light /etc/thruk/themes/themes-enabled/Light
  test -h /etc/thruk/themes/themes-enabled/.Dark  && mv /etc/thruk/themes/themes-enabled/.Dark  /etc/thruk/themes/themes-enabled/Dark
fi
# remove broken/old symlinks
for link in /etc/thruk/themes/themes-enabled/*; do test -e $link/. || rm $link; done
if [ -d /tmp/thruk_update/plugins/. ]; then
  rm -f /etc/thruk/plugins/plugins-enabled/*
  cp -rp /tmp/thruk_update/plugins/* /etc/thruk/plugins/plugins-enabled/
fi
# remove broken/old symlinks
for link in /etc/thruk/plugins/plugins-enabled/*; do test -e $link/. || rm $link; done
echo "thruk plugins enabled:" $(ls /etc/thruk/plugins/plugins-enabled/)
if [ -d /tmp/thruk_update/ssi/. ]; then
  rm -f /etc/thruk/ssi/*
  cp -rp /tmp/thruk_update/ssi/* /etc/thruk/ssi/
fi
rm -rf /tmp/thruk_update
exit 0

%preun
case "$*" in
  1)
    # Upgrade, don't do anything
  ;;
  0)
    # Uninstall, go ahead and stop before removing
    # last version will be deinstalled
    /usr/bin/thruk -a uninstallcron --local
  ;;
  *) echo case "$*" not handled in preun
esac
exit 0

%postun
set +e
case "$*" in
  0)
    # POSTUN
    rm -rf %{_localstatedir}/cache/thruk
    rm -rf %{_datadir}/thruk/root/thruk/plugins
    rmdir /etc/thruk/plugins/plugins-available 2>/dev/null
    rmdir /etc/thruk/plugins/plugins-enabled 2>/dev/null
    rmdir /etc/thruk/plugins 2>/dev/null
    rmdir /etc/thruk/bp 2>/dev/null
    rmdir /etc/thruk/panorama 2>/dev/null
    rmdir /etc/thruk/thruk_local.d 2>/dev/null
    rmdir /etc/thruk 2>/dev/null
    rmdir /usr/share/thruk/plugins/plugins-available 2>/dev/null
    rmdir /usr/share/thruk/plugins 2>/dev/null
    rmdir /usr/share/thruk 2>/dev/null
    %{insserv_cleanup}
    # remove broken/old symlinks
    for link in /etc/thruk/themes/themes-available/*;   do test -e $link/. || rm -f $link; done
    for link in /etc/thruk/themes/themes-enabled/*;     do test -e $link/. || rm -f $link; done
    for link in /etc/thruk/plugins/plugins-available/*; do test -e $link/. || rm -f $link; done
    for link in /etc/thruk/plugins/plugins-enabled/*;   do test -e $link/. || rm -f $link; done
    rmdir /usr/share/thruk/script \
          /usr/share/thruk \
          /usr/lib/thruk \
          /etc/thruk/ssi \
          /etc/thruk/action_menus \
          /etc/thruk/bp \
          /etc/thruk/panorama \
          /etc/thruk \
          2>/dev/null
    ;;
  1)
    # POSTUPDATE
    /usr/bin/thruk -a livecachestop --local >/dev/null 2>&1
    rm -rf %{_localstatedir}/cache/thruk/*
    mkdir -p /var/cache/thruk/reports
    chown -R %{apacheuser}:%{apachegroup} /var/cache/thruk
    # remove broken/old symlinks
    for link in /etc/thruk/themes/themes-available/*;   do test -e $link/. || rm -f $link; done
    for link in /etc/thruk/themes/themes-enabled/*;     do test -e $link/. || rm -f $link; done
    for link in /etc/thruk/plugins/plugins-available/*; do test -e $link/. || rm -f $link; done
    for link in /etc/thruk/plugins/plugins-enabled/*;   do test -e $link/. || rm -f $link; done
    ;;
  *) echo case "$*" not handled in postun
esac
exit 0

%post plugin-reporting
rm -f /etc/thruk/plugins/plugins-enabled/reports2
ln -s ../plugins-available/reports2 /etc/thruk/plugins/plugins-enabled/reports2
exit 0

%preun plugin-reporting
if [ -e /etc/thruk/plugins/plugins-enabled/reports2 ]; then
    rm -f /etc/thruk/plugins/plugins-enabled/reports2
fi
exit 0

%postun plugin-reporting
case "$*" in
  0)
    # POSTUN
    # try to clean some empty folders
    rmdir /etc/thruk/plugins/plugins-available 2>/dev/null
    rmdir /etc/thruk/plugins/plugins-enabled 2>/dev/null
    rmdir /etc/thruk/plugins 2>/dev/null
    rmdir /etc/thruk 2>/dev/null
    rmdir /usr/share/thruk/plugins/plugins-available 2>/dev/null
    rmdir /usr/share/thruk/plugins 2>/dev/null
    rmdir /usr/share/thruk/script 2>/dev/null
    rmdir /usr/share/thruk 2>/dev/null
    ;;
  1)
    # POSTUPDATE
    ;;
  *) echo case "$*" not handled in postun
esac
exit 0

%files
%attr(0755,root,root) %{_bindir}/thruk
%attr(0755,root,root) %{_bindir}/naglint
%attr(0755,root,root) %{_bindir}/nagexp
%config %{_sysconfdir}/thruk/ssi
%config %{_sysconfdir}/thruk/action_menus
%config %{_sysconfdir}/thruk/thruk.conf
%attr(0644,%{apacheuser},%{apachegroup}) %config(noreplace) %{_sysconfdir}/thruk/thruk_local.conf
%attr(0644,%{apacheuser},%{apachegroup}) %config(noreplace) %{_sysconfdir}/thruk/cgi.cfg
%attr(0644,%{apacheuser},%{apachegroup}) %config(noreplace) %{_sysconfdir}/thruk/htpasswd
%attr(0755,%{apacheuser},%{apachegroup}) %dir /var/log/thruk/
%config(noreplace) %{_sysconfdir}/thruk/naglint.conf
%config(noreplace) %{_sysconfdir}/thruk/log4perl.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/thruk-base
%config(noreplace) %{_sysconfdir}/bash_completion.d/thruk-base
%config(noreplace) %{_sysconfdir}/%{apachedir}/conf.d/thruk.conf
%config(noreplace) %{_sysconfdir}/%{apachedir}/conf.d/thruk_cookie_auth_vhost.conf
%{_datadir}/%{name}/plugins/plugins-available/agents
%config %{_sysconfdir}/%{name}/plugins/plugins-available/agents
%{_datadir}/%{name}/plugins/plugins-available/business_process
%config %{_sysconfdir}/%{name}/plugins/plugins-enabled/business_process
%config %{_sysconfdir}/%{name}/plugins/plugins-available/business_process
%{_datadir}/%{name}/plugins/plugins-available/conf
%config %{_sysconfdir}/%{name}/plugins/plugins-enabled/conf
%config %{_sysconfdir}/%{name}/plugins/plugins-available/conf
%{_datadir}/%{name}/plugins/plugins-available/minemap
%config %{_sysconfdir}/%{name}/plugins/plugins-enabled/minemap
%config %{_sysconfdir}/%{name}/plugins/plugins-available/minemap
%{_datadir}/%{name}/plugins/plugins-available/panorama
%config %{_sysconfdir}/%{name}/plugins/plugins-enabled/panorama
%config %{_sysconfdir}/%{name}/plugins/plugins-available/panorama
%{_datadir}/%{name}/plugins/plugins-available/shinken_features
%config %{_sysconfdir}/%{name}/plugins/plugins-enabled/shinken_features
%config %{_sysconfdir}/%{name}/plugins/plugins-available/shinken_features
%{_datadir}/%{name}/plugins/plugins-available/core_scheduling
%config %{_sysconfdir}/%{name}/plugins/plugins-available/core_scheduling
%config(noreplace) %{_sysconfdir}/thruk/themes
%config(noreplace) %{_sysconfdir}/thruk/menu_local.conf
%config(noreplace) %{_sysconfdir}/thruk/usercontent/
%config(noreplace) %{_sysconfdir}/thruk/bp/bp_functions.pm
%config(noreplace) %{_sysconfdir}/thruk/bp/bp_filter.pm
%attr(0755,root,root) %{_datadir}/thruk/thruk_auth
%attr(0755,root,root) %{_datadir}/thruk/script/thruk_fastcgi.pl
%attr(0755,root,root) %{_datadir}/thruk/script/thruk.psgi
%attr(0755,root,root) %{_datadir}/thruk/script/grafana_export.sh
%attr(0755,root,root) %{_datadir}/thruk/script/html2pdf.sh
%attr(0644,root,root) %{_datadir}/thruk/script/puppeteer.js
%attr(0755,root,root) %{_datadir}/thruk/script/install_puppeteer.sh
%attr(0755,root,root) %{_datadir}/thruk/script/pnp_export.sh
%attr(0755,root,root) %{_datadir}/thruk/script/convert_old_datafile
%attr(0755,root,root) %{_datadir}/thruk/script/check_thruk_rest
%{_datadir}/thruk/support
%{_datadir}/thruk/root
%{_datadir}/thruk/templates
%{_datadir}/thruk/themes
%{_datadir}/thruk/lib
%{_datadir}/thruk/Changes
%{_datadir}/thruk/LICENSE
%{_datadir}/thruk/menu.conf
%{_datadir}/thruk/dist.ini
%{_datadir}/thruk/thruk_cookie_auth.include
%attr(0755,root,root) %{_datadir}/thruk/fcgid_env.sh
%attr(0755,root,root) %{_datadir}/thruk/thruk_authd.pl
%docdir %{_defaultdocdir}
%{_mandir}/man3/nagexp.3*
%{_mandir}/man3/naglint.3*
%{_mandir}/man3/thruk.3*
%{_mandir}/man8/thruk.8*

%files plugin-reporting -f plugin-reporting.files
%{_sysconfdir}/thruk/plugins/plugins-available/reports2
%{_datadir}/thruk/plugins/plugins-available/reports2

%changelog
* Wed Jan 03 2024 Oden Eriksson <oe@nux.se> 3.10-1
- 3.10

* Tue Oct 10 2023 Oden Eriksson <oe@nux.se> 3.08.3-1
- 3.08.3
- requires perl-Plack and perl-Excel-Template

* Mon Jul 31 2023 Oden Eriksson <oe@nux.se> 3.08.2-1
- 3.08.2

* Fri Apr 14 2023 Oden Eriksson <oe@nux.se> 3.04-1
- 3.04

* Tue Nov 22 2022 Oden Eriksson <oe@nux.se> 3.00-0.1
- major overhaul of the specfile
- major overhaul of the deps from evaluating libthruk

* Fri Jun 12 2015 Sven Nierlein <sven@consol.de> - 2.00
- split into several subpackages

* Sat Dec 07 2013 Sven Nierlein <sven@consol.de> - 1.82
- changed to default installation routine

* Sat Apr 14 2012 Sven Nierlein <sven@consol.de> - 1.28
- added init script
- added log rotation

* Fri Feb 10 2012 Sven Nierlein <sven@consol.de> - 1.2
- First build
